<template>
  <!-- 排班信息添加 -->
  <div>
    <el-dialog
      v-loading="loading"
      :title="title + '排班信息'"
      :visible.sync="showFormDia"
      width="28%"
      :before-close="handleClose"
      top="9vh"
    >
      <div class="bbsl-scroll-pane">
        <el-form
          ref="formInfo"
          class="bbsl-scroll-form-spare"
          :rules="rules"
          :model="params"
          label-width="80px"
          style="height: auto;"
        >
          <p id="step1" class="from-title">
            <i class="el-icon-info" />
            <span>日期：{{ params.arrangeDate }}</span>
          </p>


          <el-row>
            <el-col :span="24">
              <el-form-item label="负责人">
                <el-select
                  v-model="params.headMan"
                  clearable
                  style="width:100%"
                  size="small"
                  filterable
                  multiple
                  placeholder="请选择负责人"
                >
                  <el-option-group v-for="group in members" :key="group.label" :label="group.label">
                    <el-option
                      v-for="item in group.options"
                      :key="item.id"
                      :label="item.mname"
                      :value="item.id"
                    >
                      <span style="float: left">{{ item.mname }}</span>
                      <span
                        style="float: right; color: #8492a6; font-size: 10px"
                      >{{ postformatter(item.post) }}</span>
                    </el-option>
                  </el-option-group>
                </el-select>
              </el-form-item>
              <el-form-item label="带队队长">
                <el-select
                  v-model="params.ledCaptain"
                  clearable
                  style="width:100%"
                  multiple
                  size="small"
                  filterable
                  placeholder="请选择带队队长"
                >
                  <el-option-group v-for="group in members" :key="group.label" :label="group.label">
                    <el-option
                      v-for="item in group.options"
                      :key="item.id"
                      :label="item.mname"
                      :value="item.id"
                    >
                      <span style="float: left">{{ item.mname }}</span>
                      <span
                        style="float: right; color: #8492a6; font-size: 10px"
                      >{{ postformatter(item.post) }}</span>
                    </el-option>
                  </el-option-group>
                </el-select>
              </el-form-item>
              <el-form-item label="组长">
                <el-select
                  v-model="params.groupLeader"
                  clearable
                  style="width:100%"
                  size="small"
                  filterable
                  multiple
                  placeholder="请选择组长"
                >
                  <el-option-group v-for="group in members" :key="group.label" :label="group.label">
                    <el-option
                      v-for="item in group.options"
                      :key="item.id"
                      :label="item.mname"
                      :value="item.id"
                    >
                      <span style="float: left">{{ item.mname }}</span>
                      <span
                        style="float: right; color: #8492a6; font-size: 10px"
                      >{{ postformatter(item.post) }}</span>
                    </el-option>
                  </el-option-group>
                </el-select>
              </el-form-item>
              <el-form-item label="队员姓名">
                <el-select
                  v-model="params.teammemberId"
                  clearable
                  style="width:100%"
                  multiple
                  size="small"
                  filterable
                  placeholder="请选择队员姓名"
                >
                  <el-option-group v-for="group in members" :key="group.label" :label="group.label">
                    <el-option
                      v-for="item in group.options"
                      :key="item.id"
                      :label="item.mname"
                      :value="item.id"
                    >
                      <span style="float: left">{{ item.mname }}</span>
                      <span
                        style="float: right; color: #8492a6; font-size: 10px"
                      >{{ postformatter(item.post) }}</span>
                    </el-option>
                  </el-option-group>
                </el-select>
              </el-form-item>
              <el-form-item label="内勤">
                <el-select
                  v-model="params.officeStaff"
                  clearable
                  style="width:100%"
                  multiple
                  size="small"
                  filterable
                  placeholder="请选择内勤"
                >
                  <el-option-group v-for="group in members" :key="group.label" :label="group.label">
                    <el-option
                      v-for="item in group.options"
                      :key="item.id"
                      :label="item.mname"
                      :value="item.id"
                    >
                      <span style="float: left">{{ item.mname }}</span>
                      <span
                        style="float: right; color: #8492a6; font-size: 10px"
                      >{{ postformatter(item.post) }}</span>
                    </el-option>
                  </el-option-group>
                </el-select>
              </el-form-item>
            </el-col>
          </el-row>
          <!-- <div id="step2" class="from-title">
            <i class="el-icon-info" />
            <span>同步设置其它日期</span>

          </div>-->
          <div style="text-align:right;width:100%;margin-bottom:5px">
            <el-checkbox v-model="params.isCover">同步排班</el-checkbox>
          </div>
          <div>
            <el-select
              v-model="params.selectDays"
              multiple
              clearable
              placeholder="请选择日期"
              style="width:100%"
            >
              <el-option
                v-for="item in mdays"
                :key="item.value"
                :label="item.text"
                :value="item.text"
              >
                <span style="float: left">{{ item.text }}</span>
                <span style="float: right; color: #8492a6; font-size: 13px">{{ item.week }}</span>
              </el-option>
            </el-select>
          </div>
        </el-form>
      </div>
      <span slot="footer" class="dialog-footer">
        <el-button type="primary" :loading="submiting" @click="handleSave">保 存</el-button>
        <el-button @click="handleClose">取 消</el-button>
      </span>
    </el-dialog>
  </div>
</template>
<script>
import CmgtDutyWorkarrangeApi from '@/views/Manage/duty/api/CmgtDutyWorkarrangeApi'
import dictContracts from '@/components/dict/DictSelectUtils.js'
import CommonApi from '@/views/Manage/CommonApi.js'

export default {
  name: 'CmgtDutyWorkarrangeFormDialog',
  components: {},
  data() {
    return {
      title: '新增',
      showFormDia: false,
      mdays: [],
      teams: [],
      classInfos: [],
      members: [],
      weeks: '',
      selectTeamId: '',
      params: {
        id: null,
        arrangeDate: null,
        workclassId: null,
        dataType: '1',
        teammemberId: [],
        selectMembers: [],
        headMan: [],
        officeStaff: [],
        mids: [],
        ledCaptain: [],
        groupLeader: [],
        teamId: null,
        status: '1',
        attendance: null,
        sn: null,
        memo: null,
        isDele: '0',
        isCover: false
      },
      rules: {
        arrangeDate: [
          {
            required: true,
            message: '排班日期不能为空',
            trigger: 'blur'
          }
        ],
        workclassId: [
          {
            required: true,
            message: '班种不能为空',
            trigger: 'blur'
          }
        ]
      },
      posts: [],
      loading: false,
      submiting: false
    }
  },
  created() {
    this.posts = dictContracts.getDictItemsFromCache('cmgt_post')
  },
  mounted() {
  },
  methods: {
    add(params) {
      CommonApi.loadDutyDays(params.arrangeDate, res => {
        this.mdays = res
      })
      // 合并表单项
      this.params = {
        ...this.params,
        selectDays: [params.arrangeDate],
        ...params
      }
      this.showFormDia = true
    },
    Update(item) {
      // console.log(item)
      CommonApi.loadDutyDays(item.arrangeDate, res => {
        this.mdays = res
      })

      this.params.id = item.arrId
      this.params.arrangeDate = item.arrangeDate
      this.params.workclassId = item.classId
      this.params.orgId = item.orgId
      this.params.headMan = item.headMan?.split(',').filter(_ => _) || []
      this.params.ledCaptain = item.ledCaptain?.split(',').filter(_ => _) || []
      this.params.groupLeader = item.groupLeader?.split(',').filter(_ => _) || []
      this.params.teammemberId = item.mids?.split(',').filter(_ => _) || []
      this.params.officeStaff = item.officeStaff?.split(',').filter(_ => _) || []

      this.showFormDia = true
    },
    handleClose() {
      this.params = {
        id: null,
        arrangeDate: null,
        workclassId: null,
        dataType: '1',
        teammemberId: [],
        selectMembers: [],
        headMan: [],
        mids: [],
        ledCaptain: [],
        officeStaff: [],
        groupLeader: '',
        teamId: null,
        status: '1',
        attendance: null,
        sn: null,
        memo: null,
        isDele: '0',
        orgId: null,
        isCover: false
      }
      // this.members = []
      this.title = '新增'
      this.showFormDia = false
    },

    handleSave() {

      if (!this.params.orgId) {
        this.$message.warning('系统异常，所属部门为空！')
        return
      }
      this.$refs.formInfo.validate(valid => {
        if (valid) {
          let method
          if (!this.params.id) {
            // 新增
            method = CmgtDutyWorkarrangeApi.addCmgtDutyWorkarrange
          }
          if (this.params.id) {
            // 修改
            this.title = '修改'
            method = CmgtDutyWorkarrangeApi.editCmgtDutyWorkarrange
          }

          this.submiting = true

          // 通过id查询name，返回值为逗号分隔的字符串
          const _idFindNameStr = idArr => {
            return this.members?.map(({options = []}) => {
              return options.flatMap(i => idArr.includes(i.id) ? i.mname : [])
            }).join(',') || ''
          }

          const {
            headMan = [], ledCaptain = [], groupLeader = [], teammemberId = [], officeStaff = [],
            ...params
          } = this.params

          method({
            ...params,
            headMan: headMan.join(','),
            ledCaptain: ledCaptain.join(','),
            groupLeader: groupLeader.join(','),
            teammemberId: teammemberId.join(','),
            officeStaff: officeStaff.join(','),
            headManName: _idFindNameStr(headMan),
            ledCaptainName: _idFindNameStr(ledCaptain),
            groupLeaderName: _idFindNameStr(groupLeader),
            teammemberNames: _idFindNameStr(teammemberId),
            officeStaffName: _idFindNameStr(officeStaff)
          }, res => {
            if (res.state) {
              this.$notify({
                type: 'success',
                message: this.title + '成功',
                duration: 2000
              })
              this.$parent.loadData(
                this.$parent.searchDate,
                this.$parent.orgId
              )
              this.handleClose()
            } else {
              // console.log('=====res======', res)
              // this.$message.warning(res)
            }
            this.submiting = false
          })
        }
      })
    },

    selectedTeam(value) {
      var this_ = this
      this.params.teammemberId = []
      this.members = []
      this.loading = true
      CmgtDutyWorkarrangeApi.findMembersByOrg(value, res => {
        if (res.state) {
          // this.members = res.value
          this.membersgroup(res.value)
          res.value.forEach(item => {
            if (item.teamId === value) {
              this_.params.teammemberId.push(item.id)
            }
          })
        }
        this_.loading = false
      })
    },

    membersgroup(data) {
      console.log(data)
      var groupName = new Set()
      data.forEach(item => {
        groupName.add(item.teamName)
      })
      groupName.forEach(item => {
        var options = []
        data.forEach(m => {
          if (item === m.teamName) {
            var o = {
              mname: m.mname,
              id: m.id,
              post: m.post
            }
            options.push(o)
          }
        })
        this.members.push({
          label: item,
          options: options
        })
      })
    },
    postformatter(value) {
      var name = ''
      this.posts.forEach(item => {
        if (item.value === value) {
          name = item.name
        }
      })
      return name
    }
  }
}
</script>
<style lang="scss" scoped>
.redBull {
  border: 1px solid red;
}

.bbsl-scroll-form-spare {
  width: calc(100% - 20px);
  height: calc(95vh - 500px);
  //overflow-y: auto;
  padding: 0 10px;
}
</style>
